#ifndef _TXTBL_H_
#define _TXTBL_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

struct draw{
	char *buf;
	int w, h;
};

void draw_init(struct draw *p, int w, int h);
void draw_fini(struct draw *p);
void draw_set(struct draw *p, int x, int y, char c);
void draw_set_x(struct draw *p, int x, int y, int n, char c);
void draw_set_y(struct draw *p, int x, int y, int n, char c);
void draw_put(struct draw *p, FILE *fp);


#define MAP_W_MAX	256
#define MAP_H_MAX	1024
extern int map_w, map_h;

void map_init(void);
void map_set(int x, int y, int w, int h);
int map_chk(int x, int y, int w, int h);


void rawcol_init(int nw, int nh);
void rawcol_fini(void);
void rawcol_calc_xy(void);
int rawcol_x_get(int ix);
int rawcol_y_get(int iy);
void rawcol_w_set_ex(int ix, int v);
void rawcol_h_set_ex(int iy, int v);
int rawcol_w_sum(int ix, int n);
int rawcol_h_sum(int iy, int n);
void rawcol_w_set_ex_scat(int ix, int n, int v);
void rawcol_h_set_ex_scat(int iy, int n, int v);


struct cell{
	int x, y, w, h;
	char *s;
	int div; /* '|' or '-' */
	int cen;
	int spc_top;
	int spc_tail;

	int sw, sh;
};

int cell_get(struct cell *p);

#endif
